# GitLab CI configuration file
#
# To run this locally (requires `gitlab-runner`):
#   $ gitlab-runner exec docker <job_name>

image: docker:latest

.only-default: &only-default
  only:
    - master
    - merge_requests
    - tags

stages:
  - lint
  - build
  - release

variables:
  GIT_SUBMODULE_STRATEGY: none


# Lint

.lint_template: &lint_definition
  stage: lint
  variables:
    GIT_SUBMODULE_STRATEGY: none
  <<: *only-default

lint package license:
  <<: *lint_definition
  image: "docker:latest"
  script:
    - apk update && apk add bash
    - bash test/lint/package-licenses.sh

lint config-files:
  <<: *lint_definition
  before_script:
    - apk add --update --no-cache libxml2-utils
  script: test/lint/config-files

lint buildroot:
  <<: *lint_definition
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  image: python:3-alpine
  before_script:
    - pip install six
  script: test/lint/buildroot

lint commits:
  <<: *lint_definition
  image: node:18
  before_script:
    - npm install -g @commitlint/cli@17.0.0 @commitlint/config-conventional@17.0.0 @commitlint/types@17.0.0 @commitlint/read@17.0.0 @commitlint/load@17.0.0 @commitlint/lint@17.0.0 @commitlint/format@17.0.0
  script: test/lint/commits

# Test
tests configgen:
  <<: *lint_definition
  stage: lint
  image: python:3.9-slim
  only:
    refs:
      - master
      - merge_requests
      - tags
    changes:
      - projects/configgen/**/*
  script: 
    - cd projects/configgen
    - echo "Installing dependencies"
    - pip install -r requirements.txt
    - echo "Running unittests" 
    - export PYTHONPATH=$PYTHONPATH:$(pwd) && pytest --cov=configgen
    - echo "Building configgen" 
    - python setup.py install

tests emulationstation:
  <<: *lint_definition
  stage: lint
  image: docker:latest  
  tags:
    - lintstage
  services:
    - docker:dind
  only:
    refs:
      - master
      - merge_requests
      - tags
    changes:
      - projects/frontend/**/*
  script:
    - cd projects/frontend
    - docker build . 
  artifacts:
    reports:
      junit: ./**/report.xml

tests buildroot patches:
  stage: lint
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  tags:
    - lintstage
  only:
    refs:
      - merge_requests
    changes:
      - package/*/*.patch
      - board/recalbox/patches/*/*.patch
  before_script:
    - apk update && apk add git
  script:
    - export ARCH=rpi4
    - git remote show target || git remote add target "${CI_MERGE_REQUEST_PROJECT_URL}"
    - git fetch target "${CI_MERGE_REQUEST_TARGET_BRANCH_NAME}"
    - docker build -t "recalbox-${ARCH}" .
    - WORKDIR="$(pwd)" OUTPUTDIR="$(pwd)/output"
    - docker run --rm --tmpfs /tmp:exec -v "${WORKDIR}:/work" -v "${OUTPUTDIR}:/work/output" -v "/recalbox-builds/dl:/share/dl" -e "ARCH=${ARCH}" -e "GITLAB_TOKEN_BEEBEM=${GITLAB_TOKEN_BEEBEM}" -e "GITLAB_TOKEN_THEMES=${GITLAB_TOKEN_THEMES}" "recalbox-${ARCH}" make recalbox-${ARCH}_defconfig 2>&1
    - |
      for PKG in $(git diff --name-only "target/${CI_MERGE_REQUEST_TARGET_BRANCH_NAME}" | grep -E '^(board/recalbox/patches|package/)' | sed -E 's#board/recalbox/patches/([^/]+)/.*#\1#;s#package/([^/]+)/.*#\1#' | sort | uniq); do
        if [ -d "package/$PKG" ] || [ -d "buildroot/package/$PKG" ]; then
          echo "Testing patches for $PKG"
          docker run --rm --tmpfs /tmp:exec -v "${WORKDIR}:/work" -v "${OUTPUTDIR}:/work/output" \
                                          -v "/recalbox-builds/dl:/share/dl" -e "ARCH=${ARCH}" \
                                          -e "GITLAB_TOKEN_BEEBEM=${GITLAB_TOKEN_BEEBEM}" \
                                          -e "GITLAB_TOKEN_THEMES=${GITLAB_TOKEN_THEMES}" \
                                          "recalbox-${ARCH}" make BR2_DL_DIR="/share/dl" $PKG-patch 2>&1 ||exit 1
        fi
      done

tests nvidia:
  <<: *lint_definition
  stage: lint
  image: python:3.9-slim
  only:
    refs:
      - master
      - merge_requests
      - tags
    changes:
      - projects/recalbox-hardware/videocard/**/*
  script: 
    - cd projects/recalbox-hardware/videocard
    - echo "Installing dependencies"
    - pip install -r requirements-dev.txt
    - echo "Running unittests"
    - export PYTHONPATH=$PYTHONPATH:$(pwd) && pytest --cov

# Build

.build_template: &build_definition
  stage: build
  variables:
    ARCH: arch # to build (no default)
  <<: *only-default
  before_script:
    - apk update && apk add git
    - source scripts/release/functions.sh
  script:
    # Version generation
    - set -euo pipefail
    - export RECALBOX_VERSION="${CI_COMMIT_TAG:-$(date '+%Y/%m/%d') ${CI_COMMIT_REF_SLUG} (${CI_PIPELINE_ID})}"
    - cp "${YOUTUBE_API_KEYS}" "./api_keys.json"
    # Release Note generation
    - echo -e "Recalbox ${RECALBOX_VERSION}\n" > /tmp/RELEASE-NOTES.md
    - cp RELEASE-NOTES.md RELEASE-NOTES-FULL.md
    - awk '/^## Version/ { flag=!flag; count+=1; next } flag && count < 2 {print}' RELEASE-NOTES.md >> /tmp/RELEASE-NOTES.md
    - mv /tmp/RELEASE-NOTES.md RELEASE-NOTES.md
    - cat RELEASE-NOTES.md
    # Updates type
    - |
      if echo "${CI_COMMIT_TAG:-""}" | grep -qi "alpha";then
        sed -i "s/^updates.type=.*/updates.type=alpha/g" package/recalbox-system/*/recalbox.conf
      fi
      if echo "${CI_COMMIT_TAG:-""}" | grep -qi "recalboxrgbdual";then
        sed -i "s/^updates.type=.*/updates.type=recalboxrgbdual/g" package/recalbox-system/*/recalbox.conf
      fi
      if echo "${CI_COMMIT_TAG:-""}" | grep -qi "patron";then
        sed -i "s/^updates.type=.*/updates.type=patron/g" package/recalbox-system/*/recalbox.conf
      fi
    # Build
    - docker build -t "recalbox-${ARCH}" .
    - WORKDIR="$(pwd)" CCACHE="true" OUTPUTDIR="$(pwd)/output"
    - mkdir -p ${OUTPUTDIR}
    - docker run --rm --tmpfs /tmp:exec --security-opt seccomp=unconfined -v "${WORKDIR}:/work" -v "${OUTPUTDIR}:/work/output" -v "/recalbox-builds/dl:/share/dl" -v "/recalbox-builds/ccaches/ccache-${ARCH}:/share/ccache" -e "ARCH=${ARCH}" -e "GITLAB_TOKEN_BEEBEM=${GITLAB_TOKEN_BEEBEM}" -e "GITLAB_TOKEN_THEMES=${GITLAB_TOKEN_THEMES}" -e "RECALBOX_VERSION=${RECALBOX_VERSION}" -e "RECALBOX_CCACHE_ENABLED=${CCACHE}" "recalbox-${ARCH}" 2>&1 | tee build.log | grep '>>>' || tac build.log | grep '>>>' -m 1 -B 9999 | tac
    - echo $?
    # Dist
    - export DIST_DIR="dist/${ARCH}"
    - mkdir -p "${DIST_DIR}"
    - cp ${OUTPUTDIR}/images/recalbox/* "${DIST_DIR}"
    - echo "${RECALBOX_VERSION}" >> "${DIST_DIR}/recalbox.version"
    - cp ${WORKDIR}/CHANGELOG.md "${DIST_DIR}/recalbox.changelog"
    - cp ${WORKDIR}/RELEASE-NOTES.md "${DIST_DIR}/recalbox.releasenotes"
    - cp ${WORKDIR}/RELEASE-NOTES-FULL.md "${DIST_DIR}/RELEASE-NOTES-FULL.md"
    - uploadFolderToBucket "${AWS_ACCESS_KEY_ID}" "${AWS_SECRET_ACCESS_TOKEN}" "recalbox-builds-artifacts" "dist" "${CI_PIPELINE_ID}"
    - rm -rf "${DIST_DIR}" "${OUTPUTDIR}"
  artifacts:
    name: dist-${ARCH}-${CI_PIPELINE_ID}
    when: always
    paths:
      - build.log
    expire_in: 2 mos
  tags:
    - build


build x86_64:
  <<: *build_definition
  when: manual
  variables:
    ARCH: 'x86_64'
build rpi4_64:
  <<: *build_definition
  when: manual
  variables:
    ARCH: 'rpi4_64'
build odroidgo2:
  <<: *build_definition
  when: manual
  variables:
    ARCH: 'odroidgo2'
build odroidxu4:
  <<: *build_definition
  when: manual
  variables:
    ARCH: 'odroidxu4'
build rpi1:
  <<: *build_definition
  when: manual
  variables:
    ARCH: 'rpi1'
build rpi3:
  <<: *build_definition
  when: manual
  variables:
    ARCH: 'rpi3'
build rpizero2legacy:
  <<: *build_definition
  when: manual
  variables:
    ARCH: 'rpizero2legacy'
build rpizero2:
  <<: *build_definition
  when: manual
  variables:
    ARCH: 'rpizero2'

### Release

.release_template: &release_definition
  stage: release
  tags:
    - release
  variables:
    DEPLOY_TYPE: type of the deployment (prod, review)
    BUCKET: Bucket to deploy to
  before_script:
    - source scripts/release/functions.sh
    - apk add --update-cache --no-cache xz bash
  script:
    - downloadBucketFolderTo "${AWS_ACCESS_KEY_ID}" "${AWS_SECRET_ACCESS_TOKEN}" "recalbox-builds-artifacts" "builds" "${CI_PIPELINE_ID}"
    - echo "Force 32 bits to upgrade to 64"
    - |
      if test -d "builds/rpi4";then
        cp -r builds/rpi4_64 builds/rpi4
        mv builds/rpi4/recalbox-rpi4_64.img.xz  builds/rpi4/recalbox-rpi4.img.xz
        mv builds/rpi4/recalbox-rpi4_64.img.xz.sha1  builds/rpi4/recalbox-rpi4.img.xz.sha1
        mv builds/rpi4/recalbox-rpi4_64.tar.xz  builds/rpi4/recalbox-rpi4.tar.xz
        mv builds/rpi4/recalbox-rpi4_64.tar.xz.sha1  builds/rpi4/recalbox-rpi4.tar.xz.sha1
        sed -i "s/recalbox-rpi4_64.tar.xz/recalbox-rpi4.tar.xz/g" builds/rpi4/recalbox-rpi4.tar.xz.sha1
        sed -i "s/recalbox-rpi4_64.img.xz/recalbox-rpi4.img.xz/g" builds/rpi4/recalbox-rpi4.img.xz.sha1
      fi
    - mkdir release
    - ./scripts/release/generate_external_installer_assets.sh --images-dir builds --destination-dir release
    - echo "Releasing files"
    - mv builds/* release
    - uploadFolderToBucket "${AWS_ACCESS_KEY_ID}" "${AWS_SECRET_ACCESS_TOKEN}" "${BUCKET}" "release" "latest"
    - |
      if [ "${DEPLOY_TYPE}" == "prod" ];then
        restartProxiesAfterUpgrade "${PROXIES_SSH_KEY}" "${PROXIES_SSH_USER}"
        copyFolder "${AWS_ACCESS_KEY_ID}" "${AWS_SECRET_ACCESS_TOKEN}" "${BUCKET}/latest/" "${BUCKET}/${CI_COMMIT_TAG}/"
      fi

release prod:
  <<: *release_definition
  only:
    refs:
      - tags
    variables:
      - $CI_COMMIT_TAG !~ /alpha/i && $CI_COMMIT_TAG !~ /recalboxrgbdual/i && $CI_COMMIT_TAG !~ /patron/i
  when: manual
  variables:
    DEPLOY_TYPE: prod
    BUCKET: recalbox-archive-stable
  environment:
    name: prod
    url: https://www.recalbox.com/download/

release alpha:
  <<: *release_definition
  only:
    - tags
  when: manual
  variables:
    DEPLOY_TYPE: review
    BUCKET: recalbox-archive-alpha
  environment:
    name: alpha/${CI_COMMIT_REF_SLUG}

release recalboxrgbdual:
  <<: *release_definition
  only:
    refs:
      - tags
    variables:
      - $CI_COMMIT_TAG =~ /recalboxrgbdual/i
  when: manual
  variables:
    DEPLOY_TYPE: review
    BUCKET: recalbox-archive-recalboxrgbdual
  environment:
    name: recalboxrgbdual/${CI_COMMIT_REF_SLUG}

release patron:
  <<: *release_definition
  only:
    refs:
      - tags
  when: manual
  variables:
    DEPLOY_TYPE: review
    BUCKET: recalbox-archive-patron
  environment:
    name: patron/${CI_COMMIT_REF_SLUG}

release branch:
  <<: *release_definition
  <<: *only-default
  when: manual
  only:
    - merge_requests
  variables:
    DEPLOY_TYPE: review
    BUCKET: recalbox-archive-branch
  environment:
    name: branch/${CI_COMMIT_REF_SLUG}
